//engine: JScript
//uname: redmine
//dname:  Redmine
//author:  
//descr:  Redmine
//help: inplace
//www: 
//addin: global
//addin: stdlib


/*@
C " Redmine" (redmine.js)   ""

:         Redmine
@*/

stdlib.require('ScriptForm.js', SelfScript);
global.connectGlobals(SelfScript);

SelfScript.self['macros'] = function() {
    form = loadScriptForm(SelfScript.fullPath.replace(/js$/, 'settings.ssf'), SelfScript.self);
    form.DoModal();
    form = null;
}

SelfScript.self['macros'] = function() {
	var varWnd = GetIssuesForm();
		
	if (varWnd.isOpen()) {
		
		varWnd.close();		
	} else {		
		
		varWnd.show();
	}
}

function Click(Control)
{
	(Settings, form);
	profileRoot.setValue(pflRedmineJs, Settings);
	form.Close();
}

function getSettings() {

    var s = v8New("");
    
    //   .
    s.("ApiKey", "");
    s.("ServerAddr", "");
    s.("ProjectDefault", "");
    profileRoot.createValue(pflRedmineJs, s, pflSnegopat)    
    s = profileRoot.getValue(pflRedmineJs);
    
    return s;
}

function Click(Control) {
	form.Close();
}

function OnOpen() {
	(form, Settings);
}

function GetIssuesForm() {
    if (!IssuesForm._instance)
        new IssuesForm();
    
    return IssuesForm._instance;
}

var pflRedmineJs = ' Redmine/';
var Settings = getSettings();
var IssuesForm = ScriptForm.extend({
	trackers: {},
    // disableAutoEvents: false,
	construct: function() {
		this._instance = null;
        this._super(SelfScript.fullPath.replace(/js$/, 'issues.ssf'));
		
		IssuesForm._instance = this;
    },	
    getProject: function(prjId) {
    	url = this.createURL("projects/" + prjId, "include=trackers");
    	var xhr = new ActiveXObject('MSXML2.XMLHTTP.6.0');
		xhr.open("GET", url, false);
		xhr.send();
		if (xhr.status != 200) {
			Message("   " + xhr.status + ': ' + xhr.statusText);
			return JSON.parse('{"project":{"trackers":[]}}');
		}
		return JSON.parse(xhr.responseText);
    },
    createURL: function(page, prms) {
    	return Settings.ServerAddr + "/" + page + ".json?nometa=1&limit=1000&key=" + Settings.ApiKey + "&" + prms;
    },
    getIssues: function(prjId) {
    	url = this.createURL("issues", "project_id=" + prjId + "&assigned_to_id=me&sort=priority:desc&athro_id=me");
    	var xhr = new ActiveXObject('MSXML2.XMLHTTP.6.0');
		xhr.open("GET", url, false);
		xhr.send();
		if (xhr.status != 200) {
			Message("   " + xhr.status + ': ' + xhr.statusText);
			return JSON.parse('{"project":{"trackers":[]}}');
		}
		return JSON.parse(xhr.responseText);
    },
    getProjects: function() {
    	url = this.createURL("projects");
    	var xhr = new ActiveXObject('MSXML2.XMLHTTP.6.0');
		xhr.open("GET", url, false);
		xhr.send();
		if (xhr.status != 200) {
			Message("   " + xhr.status + ': ' + xhr.statusText);
			return JSON.parse('{"projects":[]}');
		}
		return JSON.parse(xhr.responseText);
    },
	loadProject: function(prjId) {
    	line = this.form.issues..();
    	prj = this.getProject(prjId).project;
    	for (i in prj.trackers) {
	    	line = this.form.issues..();
	    	line.subject = prj.trackers[i].name;
	    	this.trackers[prj.trackers[i].id] = line;
    	}
		this.loadIssues(prjId);
    },
    loadIssues: function(prjId) {
    	issues = this.getIssues(prjId).issues;
    	for (i in issues) {
    		iss = issues[i];
    		tracker = this.trackers[iss.tracker.id];
    		line = tracker..();
    		line.tracker = iss.tracker.id;
    		line.status = iss.status.name;
    		line.priority = iss.priority.name;
    		line.author = iss.author.name;
    		if (iss.assigned_to != undefined)
	    		line.assigned_to = iss.assigned_to.name;
	    	if (iss.subject != undefined)
	    		line.subject = iss.subject;
    		line.description = iss.description;
    		line.start_date = iss.start_date;
    		line.done_ratio = iss.done_ratio;
    		line.updated_on = iss.updated_on;
    		line.id = iss.id;
    		line.project = iss.project.id;
    	}
    },
	Form_OnOpen: function () {
		this.CommandBar1(undefined);
    },
    
    CommandBar1: function() {
    	projects = this.getProjects();
		prjId = -1;
		curPrj = -1;
		this.form.Controls...();
		for (index in projects.projects)
		{
			prj = projects.projects[index];
			
			this.form.Controls...(prj.id, prj.name);
			if (prj.name == Settings.ProjectDefault)
				curPrj = prj.id;
		}
		this.form.CurrentProject = curPrj;
		
		this.loadProject(curPrj);
		
    },
    TableBox1_: function(, , ) {
    	 = .val;
    	 = .;
    	if (.() == 0)
	    	...(.);
	   	else
	   		...(.);

    },
    TableBox1_: function(Control) {
    	line = this.form.Controls.TableBox1.;
    	this.form.Controls.GroupBox1. = line.subject;
    	this.form.id = line.id;
    	this.form.author = line.author;
    	this.form.start_date = line.start_date;
    	this.form.done_ratio = line.done_ratio;
    	this.form.description = line.description;
    },
    TableBox1_: function(, , , ) {
    	line = .val;
    	if (line.() == 0) return;
    	url = Settings.ServerAddr + "/issues/" + line.id;
    	shell = new ActiveXObject("shell.application");
    	shell.ShellExecute(url);
    },
    _: function(Control) {
    	this.loadProject(this.form.CurrentProject);
    }
});